Program Tetra_Game;

Uses
  Crt, Dos;

Type
  ScreenType=array[1..50,1..80] of record
    ch:char;
    at:byte;
  end;

Const
  N=7;
  Level:byte=0;
  speed:byte=30;
  Score:Longint=0;
  Line:Word=0;
  Block:Array[1..N,1..4,1..4] of char=
  (
  ((#0,#0,#0,#0),
   (#0,#0,#0,#0),
   ('','','',''),
   (#0,#0,#0,#0)),
  ((#0,#0,#0,#0),
   ('',#0,#0,#0),
   ('','','',#0),
   (#0,#0,#0,#0)),
  ((#0,#0,#0,#0),
   (#0,#0,'',#0),
   ('','','',#0),
   (#0,#0,#0,#0)),
  ((#0,#0,#0,#0),
   (#0,'','',#0),
   (#0,'','',#0),
   (#0,#0,#0,#0)),
  ((#0,#0,#0,#0),
   (#0,'',#0,#0),
   (#0,'','',#0),
   (#0,#0,'',#0)),
  ((#0,#0,#0,#0),
   (#0,#0,'',#0),
   (#0,'','',#0),
   (#0,'',#0,#0)),
  ((#0,#0,#0,#0),
   (#0,'',#0,#0),
   (#0,'','',#0),
   (#0,'',#0,#0))
  );
  MaxX=45; MinX=35;
  MaxY=40; MinY=15;
  GameOver:Boolean=False;
Var
  x, y:byte;
  OrigMode:integer;
  key:Char;
  CurrBNo:byte;
  NextB:byte;
  CurrB:Array[1..4,1..4] of char;
  Screen:ScreenType Absolute $B800:0;
  Time: Longint;
  Next: Boolean;
  c:byte;
  x1,y1:byte;
  tt:boolean;
  diff:byte;
  Style:byte;

Procedure WriteXY(X, Y, C, Color: Byte);
{Color = 255 : no change}
Begin
  Dec(X);
  Dec(Y);
  If c <> 0 then
    Begin
      Mem[$B800:(X+Y*(Lo(WindMax)+1))*2]:=c;
      If color <> 255 then
        Mem[$B800:(X+Y*(Lo(WindMax)+1))*2+1]:=color;
    end;
End;

Procedure LevelUp;
Begin
  If level < 30 then
    begin
      Inc(Level);
      Speed:=(31-Level) div diff;
    end
  else
    Begin
      Writeln('Congratulation! You Win!');
      GameOver:=True;
    End;
end;

Procedure WriteB(X, Y:Byte; p:pointer; check:Boolean);
Type
  Bt=Array[1..4,1..4] of char;
Var
  i,j:byte;
  B:^Bt;
Begin
  B:=p;
  for i:=0 to 3 do
    for j:=0 to 3 do
      If not check then
        WriteXY(X+j, Y+i, Ord(b^[i+1][j+1]), c)
      else
        If (X+j <= MaxX) and (X+j >= MinX) and (Y+i <= MaxY) and (Y+i >= MinY) then
          WriteXY(X+j, Y+i, Ord(b^[i+1][j+1]), c);
End;

procedure SetCursor(Style:word);assembler;
{Off=$2000;On=$0607;Full=$0007;Half=$0407;}
asm
  mov ah,1
  mov bh,2
  mov cx,style
  int 10h
end;

procedure Box(X1, Y1, X2, Y2, Color:byte);
Var
  X, Y: Byte;
Begin
  WriteXY(X1, Y1, 218, Color);
  WriteXY(X2, Y1, 191, Color);
  WriteXY(X1, Y2, 192, Color);
  WriteXY(X2, Y2, 217, Color);
  For X:=X1 + 1 to X2 - 1 do
    Begin
      WriteXY(X, Y1, 196, Color);
      WriteXY(X, Y2, 196, Color);
    End;
  For Y:=Y1 + 1 to Y2 - 1 do
    Begin
      WriteXY(X1, Y, 179, Color);
      WriteXY(X2, Y, 179, Color);
    End;
End;

Procedure ClearNext;
Var
  i, j:byte;
Begin
  for j:=6 to 9 do
    for i:=46 to 49 do
      Screen[j,i].ch:=' ';
End;

Function Check(X1,Y1:Byte):Boolean;
Var
  i, j:Byte;
  t:boolean;
  Temp:^ScreenType;
Begin
  New(Temp);
  Temp^:=Screen;
  t:=True;
  For j:=0 to 3 do
    for i:=0 to 3 do
      If (CurrB[i+1,j+1] = #219) then
        Temp^[Y+i,X+j].ch:=#32;
  For j:=0 to 3 do
    for i:=0 to 3 do
      If (CurrB[i+1,j+1] = #219) and (Temp^[Y1+i,X1+j].ch <> #32) then
        t:=false;
  Dispose(Temp);
  Check:=t;
End;

Procedure Down;
Var
  i,j:byte;
Begin
  for i:=0 to 3 do
    for j:=0 to 3 do
      If CurrB[i+1,j+1] = #219 then
        WriteXY(X+j, Y+i, 32, 255);
  Inc(Y);
  WriteB(X, Y, @CurrB, True);
End;

Procedure Left;
Var
  i,j:byte;
Begin
  for i:=0 to 3 do
    for j:=0 to 3 do
      If CurrB[i+1,j+1] = #219 then
        WriteXY(X+j, Y+i, 32, 255);
  Dec(X);
  WriteB(X, Y, @CurrB, True);
End;

Procedure Right;
Var
  i,j:byte;
Begin
  for i:=0 to 3 do
    for j:=0 to 3 do
      If CurrB[i+1,j+1] = #219 then
        WriteXY(X+j, Y+i, 32, 255);
  Inc(X);
  WriteB(X, Y, @CurrB, True);
End;

Procedure CheckLine;
Var
  i, j:Byte;
  Full:boolean;
  no:Byte;
  st:string[10];

  Procedure cut(n:byte);
  Var
    i,j:byte;
  Begin
    for j:=n downto MinY+1 do
      for i:=MinX to MaxX do
          Screen[j,i]:=Screen[j-1,i];
  End;

Begin
  st[0]:=#10;
  no:=0;
  for i:=MinY to MaxY do
    Begin
      Full:=True;
      For j:=MinX to MaxX do
        If Screen[i,j].ch <> #219 then
          Full:=False;
      If Full then
        Begin
          cut(i);
          inc(no);
        end;
    End;
  Inc(Line, no);
  If no > 0 then
    Inc(Score, no*100+Sqr(no)*10+10*Diff);
End;

Procedure Init;
Begin
  Randomize;
  Writeln('Tetris 1.00. Copyright(c) 1997 by So Chun Kit. All rights reserved.');
  Write('Level (1-15) : ');
  Repeat
    Readln(Diff);
  Until (Diff >= 1) and (Diff <= 15);
  Writeln('Style 1 : Down one row when press down arrow');
  Writeln('Style 2 : Down many row when press down arrow');
  Repeat
    Write('Style : ');
    Readln(Style);
  Until Style in [1,2];
  Next:=True;
  OrigMode:=LastMode;
  TextMode(co80+Font8x8);
  SetCursor($2000);
  Box(5, 5, 25, 9, 7);
  GotoXY(7,6);
  Write('Level : ',level);
  GotoXY(7,7);
  Write('Line  : ',Line);
  GotoXY(7,8);
  Write('Score : ',Score);
  GotoXY(46, 4);
  Write('Next');
  GotoXY(56, MinY);
  Write('Key :');
  Box(45, 5, 50, 10, 7);
  Box(55, MinY+1, 75, MinY+7, 7);
  GotoXY(56, MinY+2);
  Write('Up Arrow    : Turn');
  GotoXY(56, MinY+3);
  Write('Down Arrow  : Down');
  GotoXY(56, MinY+4);
  Write('Left Arrow  : Left');
  GotoXY(56, MinY+5);
  Write('Right Arrow : Right');
  GotoXY(56, MinY+6);
  Write('Quit        : Q');
  Box(MinX-1, MinY-1, MaxX+1, MaxY+1, 7);
  CurrBNo:=Random(N)+1;
  NextB:=Random(N)+1;
  Move(Block[CurrBNo], CurrB, SizeOf(CurrB));
  Time:=memL[$0040:$006C];
  speed:=31 div Diff;
End;

Procedure Done;
Begin
  SetCursor($0607);
  TextMode(OrigMode);
  Writeln('Level : ', level);
  Writeln('Line  : ', line);
  Writeln('Score : ', score);
  Writeln('Game Over!');
End;

Procedure Turn;
Var
  i, j:byte;
  Temp, Temp2:Array[1..4,1..4] of char;
  t:boolean;
Begin
  for i:=0 to 3 do
    for j:=0 to 3 do
      If CurrB[i+1,j+1] = #219 then
        WriteXY(X+j, Y+i, 32, 255);
  Move(CurrB, Temp2, SizeOf(CurrB));
  For i:=1 to 4 do
    for j:=1 to 4 do
      Temp[i,j]:=CurrB[5-j,i];
  Move(Temp, CurrB, SizeOf(CurrB));
  For j:=0 to 3 do
    for i:=0 to 3 do
      If (CurrB[i+1,j+1] = #219) and (Screen[Y+i,X+j].ch <> #32) then
        t:=false;
  If Not t then
    Move(Temp2, CurrB, SizeOf(CurrB));
  WriteB(X, Y, @CurrB, True);
End;

Begin
  Init;
  Repeat
    GotoXY(7,6);
    Write('Level : ',level);
    GotoXY(7,7);
    Write('Line  : ',Line);
    GotoXY(7,8);
    Write('Score : ',Score);
    If keypressed then
      Begin
        key:=Readkey;
        if key = #0 then
          key:=readkey;
        Case key of
          #72:Turn;
          #80:If Style=1 then
                Begin
                  If Check(x, y+1) then
                    Down
                  else
                    Begin
                      CheckLine;
                      If (Line div 10) > Level then
                        LevelUp;
                      next:=true;
                      Inc(Score,30+3*Diff);
                    End;
                End
              Else
                Begin
                  While Check(x, y+1) do
                    Down;
                  CheckLine;
                  If (Line div 10) > Level then
                    LevelUp;
                  next:=true;
                  Inc(Score,30+3*Diff);
                End;
          #75:If Check(x-1, y) then
                Left;
          #77:If Check(x+1, y) then
                Right;
          'q','Q':GameOver:=True;
        End;
      End
    else
      Begin
        If Next then
          Begin
            CurrBNo:=NextB;
            NextB:=Random(n)+1;
            Move(Block[CurrBNo], CurrB, SizeOf(CurrB));
            X:=(MinX+MaxX) div 2-2;
            Y:=MinY;
            C:=Random(7)+1;
            tt:=True;
            For x1:=0 to 3 do
              for y1:=0 to 3 do
                If (CurrB[y1+1,x1+1] = #219) and (Screen[Y+y1,X+x1].ch <> #32) then
                  tt:=false;
            If not tt then
              GameOver:=True
            Else
              Begin
                WriteB(X, Y, @CurrB, True);
                Next:=False;
                ClearNext;
                WriteB(46, 6, @Block[NextB], False);
              End;
          End;
        If memL[$0040:$006C] - Time >= speed then
          Begin
            If Check(X, Y+1) then
              Down
            else
              Begin
                CheckLine;
                If (Line div 10) > Level then
                  LevelUp;
                Next:=True;
                Inc(Score,30+3*Diff);
              End;
            Time:=memL[$0040:$006C];
          End;
      End;
  Until GameOver;
  Done;
End.
